	PAGE	,132
	TITLE MNEMZ80 - 21 OCT 1985

; ****************************************************************
; **								**
; **		      MNEMONIC AND BYTES TABLES 		**
; **								**
; ** MNEMONIC TABLES CONTAIN ASCII STRINGS THAT ARE TO BE USED	**
; ** AS MNEMONICS FOR THE PROGRAM DASMZ80.  ENTRIES ARE SEPAR-	**
; ** ATED BY ASCII RECORD SEPARATORS, AND ARE ORGANIZED BY	**
; ** ASCENDING OP-CODE.  UNDEFINED OP-CODES ARE ASSIGNED THE	**
; ** MNEMONIC "?".  BYTES TABLES CONTAIN THE NUMBER OF BYTES	**
; ** THAT THE ASSOCIATED INSTRUCTIONS REQUIRE.  UNDEFINED OP-	**
; ** CODES ARE ASSIGNED ZERO BYTES.  OP-CODES CB, DD, ED, AND	**
; ** FD ARE ASSIGNED BYTE COUNTS OF 5, 6, 7, AND 8, RESPECTIVE-	**
; ** LY, IN THE FIRST TABLE TO INDICATE THAT THEIR SUBTABLES	**
; ** ARE TO BE ACCESSED.  FURTHER, OP-CODE CB IN THE DD AND FD	**
; ** GROUPS ARE ASSIGNED BYTE COUNTS OF 9 AND 10, RESPECTIVELY,	**
; ** TO INDICATE THAT THEIR SUBTABLES ARE TO BE ACCESSED.	**
; **								**
; ****************************************************************

; ..... MODULE CONNECTION POINTS .....

	PUBLIC	MNEM_STRINGS
	PUBLIC	BYTES
	PUBLIC	CB_STRINGS
	PUBLIC	CB_BYTES
	PUBLIC	DD1_STRINGS
	PUBLIC	DD1_BYTES
	PUBLIC	DD2_STRINGS
	PUBLIC	DD2_BYTES
	PUBLIC	ED_STRINGS
	PUBLIC	ED_BYTES
	PUBLIC	FD1_STRINGS
	PUBLIC	FD1_BYTES
	PUBLIC	FD2_STRINGS
	PUBLIC	FD2_BYTES


; ..... CONSTANTS .....

TAB	EQU	09H		; ASCII TAB
RS	EQU	1EH		; ASCII RECORD SEPARATOR
FS	EQU	1CH		; ASCII FIELD SEPARATOR
APOST	EQU	27H		; ASCII APOSTROPHE


DATA	SEGMENT PUBLIC		; DATA SEGMENT

	INCLUDE ZDINSTAB.INC
	INCLUDE ZDCBTAB.INC
	INCLUDE ZDDDTAB1.INC
	INCLUDE ZDDDTAB2.INC
	INCLUDE ZDEDTAB.INC
	INCLUDE ZDFDTAB1.INC
	INCLUDE ZDFDTAB2.INC


DATA	ENDS

	END

