	PAGE	,132
	TITLE	VDEL - VERIFIED DELETION UTILITY
;
; THIS PROGRAM IS IN THE PUBLIC DOMAIN
;
CDGROUP	GROUP	CODE,DATA
;
; MACROS
;
DOS	MACRO FCN_CODE,DX_ARG
	MOV	AH,FCN_CODE
	IFNB	<DX_ARG>
	LEA	DX,DX_ARG
	ENDIF
	INT	21H
	ENDM
;
MSG	MACRO	MESSAGE,ERRORLEVEL
	DOS	PRINT_MESSAGE,MESSAGE
	IFNB	<ERRORLEVEL>
	MOV	AL,ERRORLEVEL
	JMP	EXIT
	ENDIF
	ENDM
;
SHOW	MACRO	ARG
	MOV	DL,ARG
	DOS	PRINT_CHAR
	ENDM
;
ONERR	MACRO	MESSAGE,ERRORLEVEL
	LOCAL	OKAY
	JNC	OKAY
	IFNB	<ERRORLEVEL>
	MSG	MESSAGE,ERRORLEVEL
	ELSE
	MSG	MESSAGE
	ENDIF
OKAY:
	ENDM
	PAGE
DATA	SEGMENT PARA
;
; DOS FUNCTION NUMBER EQUATES
;
PRINT_CHAR	EQU 02H	; PRINT A CHARACTER
GETKEY_NOECHO	EQU 08H	; GET A KEYSTROKE W/O ECHO
PRINT_MESSAGE	EQU 09H	; PRINT A MESSAGE TERMINATED BY "$"
SELECT_DRIVE	EQU 0EH	; SELECT CURRENT DRIVE
CURRENT_DRIVE	EQU 19H	; GET CURRENT DRIVE NUMBER
SETDTA		EQU 1AH	; SET DISK TRANSFER ADDRESS
GET_VERSION	EQU 30H	; GET DOS VERSION
CHANGE_DIR	EQU 3BH	; CHANGE DIRECTORY
DELETE_FILE	EQU 41H	; DELETE SOMETHING
FILE_ATTR	EQU 43H	; FILE ATTRIBUTE GET/SET
CURRENT_DIR	EQU 47H	; GET CURRENT DIRECTORY
TERMINATE	EQU 4CH                 ; PROGRAM TERMINATE
SEARCH_FIRST	EQU 4EH	; FIND THE FIRST DIRECTORY ENTRY
SEARCH_NEXT	EQU 4FH	; KEEP LOOKING
;
; CHARACTER-VALUE EQUATES
;
BEEP	EQU	07H
TAB	EQU	09H
LF	EQU	0AH
CR	EQU	0DH
ESC	EQU	1BH
SPACE	EQU	20H
ENDMSG	EQU	'$'
PATHMARK	EQU	'\'
DRIVEIND	EQU	':'
PERIOD	EQU	'.'
ASTERISK	EQU	'*'
QUESTION	EQU	'?'
YES1	EQU   'y'
YES2	EQU   'Y'
NO1	EQU	'n'
NO2	EQU	'N'
;
; DATA AND MESSAGES
;
SEARCH_WORK	DB  43 DUP(?)	; SEARCH WORK-AREA
FILEATTR		EQU BYTE PTR SEARCH_WORK+21 ; FILE ATTR IN WORK AREA
FILEATTR_READ	EQU 1FH	    ;   "WRITE-PROTECT" ATTR BITS
FILENAME		EQU BYTE PTR SEARCH_WORK+30 ; FILE NAME IN WORK AREA
CURRDRIVE	DB  ?	; CURRENT DRIVE NUMBER AT START
DELDRIVE		DB  ?	; DRIVE WHERE DELETES HAPPEN
MAXDRIVE		DB  ?	; MAXIMUM DRIVE NUMBER
ROOTDIR		DB  '\',0	; VALID-FORMAT ROOT DIR NAME
WILDCARD		DB  0	; "WILD CARDS FOUND" SWITCH
ALLFILES		DB  '*.*',0	; "ALL FILES" SPECIFICATION
START_DIR	DB  '\',64 DUP(?)	; CURRENT DIRECTORY AT START
DEL_DIR		DB  '\',64 DUP(?)	; CURRENT DIRECTORY ON TARGET DRIVE
VERSIONBAD	DB  BEEP,'DOS 2.0 or above required.',CR,LF,ENDMSG
NOPARAM		DB  BEEP,'  Command format: VDEL [d:][path]filespec',CR,LF,ENDMSG
BADDRIVE		DB  BEEP,'Invalid drive specification.',CR,LF,ENDMSG
BADPATH		DB  BEEP,'Invalid path specification.',CR,LF,ENDMSG
NOMATCH		DB  BEEP,'No matching files.',CR,LF,ENDMSG
INTRO		DB  CR,LF,'Press Y to delete, N to skip, Esc to stop.',CR,LF,ENDMSG
LEADIN		DB  TAB,'Delete ',ENDMSG
TAIL		DB  '? ',ENDMSG
NODEL		DB  BEEP,'File is write-protected.',CR,LF,ENDMSG
YES		DB  'Yes',CR,LF,ENDMSG
NO		DB  'No',CR,LF,ENDMSG
STOP		DB  'Stop',CR,LF,ENDMSG
THATSIT		DB  CR,LF,'No more matching files.',CR,LF,ENDMSG
;
DATA	ENDS
	PAGE
CODE	SEGMENT PARA
;
	ASSUME CS:CDGROUP,DS:CDGROUP,ES:CDGROUP,SS:CDGROUP
;
	ORG	80H
PARAMLEN	LABEL	BYTE	; PARAMETER LENGTH
	ORG	81H
PARAMDAT	LABEL	BYTE	; PARAMETER DATA
;
	ORG 100H
;
START:
;
	DOS	GET_VERSION	; GET DOS VERSION
;
	CMP	AL,2	; 2.0 OR ABOVE?
	JAE	VERSION_OK	; YES
;
	MSG	VERSIONBAD	; REPORT VERSION ERROR
;
	XOR	AX,AX	; OLD-STYLE TERMINATE FUNCTION
	INT	21H	; CALL DOS
;
VERSION_OK:
;
	DOS	SETDTA,SEARCH_WORK
;
	DOS	CURRENT_DRIVE	; GET CURRENT DRIVE NUMBER
	MOV	CURRDRIVE,AL	; STASH IT AWAY
	MOV	DELDRIVE,AL	; DEFAULT DELETE-DRIVE
	MOV	DL,AL	; COPY CURRENT DRIVE NUMBER
	DOS	SELECT_DRIVE	; FIND OUT MAX DRIVE NUMBER
	MOV	MAXDRIVE,AL	; STASH IT AWAY
;
	XOR	DL,DL	; SET FOR CURRENT DEFAULT DRIVE
	LEA	SI,START_DIR+1	; POINT TO RESULT AREA
	DOS	CURRENT_DIR	; GET DIRECTORY NAME
;
	MOV	CL,PARAMLEN	; PARAMETER LENGTH IN CX
	XOR	CH,CH	;   (ZERO HIGH-ORDER BYTE)
	JCXZ	PARAM_MISSING	; EXIT IF PARAM LENGTH IS ZERO
;
	LEA	DI,PARAMDAT	; POINT TO PARAMETER DATA
	MOV	AL,SPACE	; SCAN-OUT
	REP	SCASB	;  LEADING SPACES
	JE	PARAM_MISSING	; IF ALL SPACES, EXIT
;
	DEC	DI	; BACK-UP ONE BYTE
	INC	CX	; RESET BYTE-COUNT
	MOV	SI,DI	; SI POINTS TO FIRST NON-BLANK
	LEA	DI,PARAMDAT	; DI POINTS TO FIRST PARAM BYTE
	XOR	BX,BX	; BX POINTS TO END OF PATH SPEC
;
	CMP	BYTE PTR [SI]+1,DRIVEIND ; PARAMETER CONTAINS DRIVE LETTER?
	JE	SET_DRIVE	; YES
	JMP	SHORT PARAM_LOOP	; NO
;
PARAM_MISSING:
;
	MSG	NOPARAM,12	; REPORT ERROR AND TERMINATE
;
SET_DRIVE:
;
	DEC	CX	; DROP TWO BYTES FROM
	DEC	CX	;   PARAMETER SIZE
;
	LODSW		; GET DRIVE LETTER (':' IN AH)
;
	CMP	AL,7AH	; LETTER LOWER-CASE 'Z' OR BELOW?
	JA 	BAD_DRIVE	; NO - ERROR
	CMP	AL,61H	; LETTER LOWER-CASE 'A' OR ABOVE?
	JB 	UPPER_DRIVE	; NO - ASSUME UPPER CASE
;
	AND	AL,5FH	; CONVERT LOWER-CASE TO UPPER-CASE
;
UPPER_DRIVE:
;
	SUB	AL,'A'	; CONVERT TO DRIVE NUMBER
;
	CMP	AL,MAXDRIVE	; IS THE DRIVE LEGAL?
	JNB	BAD_DRIVE	; NO - GO REPORT ERROR
;
	MOV	DELDRIVE,AL	; SAVE DELETE-DRIVE NUMBER
;
	MOV	DL,AL	; COPY DRIVE NUMBER TO DL
	DOS	SELECT_DRIVE	; SET NEW DRIVE
;
	DOS	CURRENT_DRIVE	; GET CURRENT DRIVE NUMBER
	CMP	AL,DELDRIVE	; DID DRIVE ACTUALLY RESET?
 	JE	GET_DRIVE_DIR	; YES - GO GET CURRENT DIRECTORY
;
	MOV	DELDRIVE,AL	; DEFAULT DELETE-DRIVE
;
BAD_DRIVE:
;
	MSG	BADDRIVE,16	; REPORT ERROR AND TERMINATE
;
GET_DRIVE_DIR:
;
	PUSH	SI	; SAVE PARAMETER POINTER
;
	XOR	DL,DL	; SET FOR CURRENT DEFAULT DRIVE
	LEA	SI,DEL_DIR+1	; POINT TO RESULT AREA
	DOS	CURRENT_DIR	; GET DIRECTORY NAME
;
	POP	SI	; RESTORE PARAMETER POINTER
;
	JCXZ	PARAM_END	; ONLY DRIVE SPECIFIED, BYPASS SCAN
;
PARAM_LOOP:
;
	LODSB 	; GET PARAMETER BYTE
;
	CMP	AL,SPACE	; SPACE? (ENDS PARAMETER)
	JE	PARAM_END	; YES
;
	CMP	AL,PATHMARK	; PATH-SPEC MARKER?
	JNE	NOT_PATH	; NO
;
	MOV	BX,DI	; SAVE MARKER LOCATION
;
NOT_PATH:
;
	CMP	AL,ASTERISK	; WILDCARD?
	JE	SET_WILDCARD	; YES
;
	CMP	AL,QUESTION	; WILDCARD?
	JE	SET_WILDCARD	; YES
;
	JMP	SHORT NOT_WILDCARD
;
SET_WILDCARD:
;
	MOV	WILDCARD,0FFH	; SET "WILD CARD FOUND"
;
NOT_WILDCARD:
;
	STOSB		; STORE PARAMETER BYTE
;
	LOOP	PARAM_LOOP	; LOOP FOR MORE
;
PARAM_END:
;
	MOV	BYTE PTR [DI],0	; STICK A ZERO AT THE END
;
	LEA	SI,PARAMDAT	; POINT TO PARAMETER DATA
;
	AND	BX,BX	; ANY PATH SPEC?
	JZ	NO_PATH	; NO- PROCEED
;
	MOV	BYTE PTR [BX],0	; STICK A ZERO AT PATH MARKER
;
	LEA	DI,[BX]+1	; POINT TO FILE NAME
	PUSH	DI	; SAVE FILE NAME POINTER
;
	CMP	BX,SI	; ROOT DIRECTORY SPECIFIED?
	JNE	NOT_ROOT	; NO
;
	LEA	SI,ROOTDIR	; POINT TO VALID ROOT DIR SPEC
;
NOT_ROOT:
;
	DOS	CHANGE_DIR,[SI]	; CHANGE DIRECTORY
;
	POP	SI	; RESTORE FILE NAME POINTER
;
	ONERR	BADPATH,16	; EXIT IF ERROR
;
NO_PATH:
;
	CMP	BYTE PTR [SI],0	; NULL FILESPEC?
	JE	SET_ALLFILES	; YES - SET TO "FIND ALL FILES"
;
	CMP	WILDCARD,0	; ANY WILDCARDS IN FILESPEC?
	JNE	NOT_SUBDIRECTORY	; YES - SPEC CAN'T BE SUBDIRECTORY
;
	XOR	AL,AL	; SET "GET ATTRIBUTE" OPERATION
	DOS	FILE_ATTR,[SI]	; CALL DOS FOR ATTRIBUTE
;
	TEST	CL,10H	; IS IT A SUBDIRECTORY?
	JZ	NOT_SUBDIRECTORY	; NO
;
	DOS	CHANGE_DIR,[SI]	; CHANGE DIRECTORY
;
SET_ALLFILES:
;
	LEA	SI,ALLFILES	; POINT TO "FIND ALL FILES" SPEC
;
NOT_SUBDIRECTORY:
;
	XOR	CX,CX	; ZERO ATTRIBUTE MASK
	DOS	SEARCH_FIRST,[SI]	; FIND FIRST ENTRY
	ONERR	NOMATCH,8	; IF NONE, REPORT AND TERMINATE
;
	MSG	INTRO	; TELL 'EM WHAT TO DO
;
; THE MAIN LOOP:
;
CYCLE:
;
	MSG	LEADIN	; WRITE PREFIX TO FILE NAME
;
	LEA	SI,FILENAME	; POINT TO NAME
;
FILENAME_LOOP:
;
	LODSB		; THIS LOOP PRINTS THE NAME
;
	OR	AL,AL	; END OF NAME?
	JZ	FILENAME_END	; YES
;
	SHOW	AL	; WRITE FILE NAME BYTE
;
	JMP	SHORT FILENAME_LOOP	; LOOP FOR NEXT BYTE
;
FILENAME_END:
;
	MSG	TAIL	; WRAP UP THE DISPLAYED LINE
;
VERIFY:
;
	DOS	GETKEY_NOECHO	; READ THE USER'S ANSWER
;
	OR	AL,AL	; EXTENDED ACSII CODE?
	JE	BAD_KEY
;
	CMP	AL,ESC	; QUIT?
	JE 	QUIT
;
	CMP	AL,YES1	; DELETE?
	JE	KILLIT
	CMP	AL,YES2
	JE	KILLIT
;
	CMP	AL,NO1	; NO DELETE?
	JE	KEEPIT
	CMP	AL,NO2
	JE	KEEPIT
;
BAD_KEY:
;
	SHOW	BEEP	; USER CAN'T TYPE ...
;
	JMP	SHORT VERIFY
;
KILLIT:
;
	TEST	FILEATTR,FILEATTR_READ	; CAN WE ACTUALLY DELETE THE FILE?
	JNZ	NO_KILL	; NO
;
	MSG	YES	; REPORT "YES"
;
	DOS	DELETE_FILE,FILENAME	; WHEEEEEEEEE
;
	JMP	SHORT NEXT	; GO DO NEXT FILE
;
NO_KILL:
;
	MSG	NODEL	; SAY WE CAN'T DELETE
;
	JMP	SHORT NEXT	; GO DO NEXT FILE
;
KEEPIT:
;
	MSG	NO
;
NEXT:
;
	DOS	SEARCH_NEXT,SEARCH_WORK	; FIND THE NEXT FILE
;
	ONERR THATSIT,0	; IF NONE, TERMINATE
;
	JMP	CYCLE	; LOOP FOR NEXT FILE
;
QUIT:
;
	MSG	STOP,4	; REPORT STOP REQ AND TERMINATE
;
EXIT:
;
	PUSH	AX	; SAVE ERRORLEVEL
;
	MOV	AL,CURRDRIVE	; GET CURRENT DRIVE AT START
	CMP	AL,DELDRIVE	; DIFFERENT DELETE-DRIVE?
	JE	SAME_DRIVE	; NO

	DOS	CHANGE_DIR,DEL_DIR	; RESET DELETE-DRIVE DIRECTORY
;
	MOV	DL,CURRDRIVE	; GET CURRENT DRIVE AT START
	DOS	SELECT_DRIVE	; RESET TO DRIVE AT START
;
SAME_DRIVE:
;
	DOS	CHANGE_DIR,START_DIR	; RESET TO DIRECTORY AT START
;
	POP	AX	; RESTORE ERRORLEVEL
;
	DOS	TERMINATE               ; TERMINATE PROGRAM
;
CODE	ENDS
;
	END	START
